/*
 * MSend.c - envia um bloco de memoria compartilhada
 */

#define INCL_DOSQUEUES
#define INCL_DOSPROCESS

#include <string.h>

#include <pwicqapi.h>
#include "icqqueue.h"

/*---[ Implementation ]-------------------------------------------------------*/

APIRET icqSendMemBlock(const char *uin, ULONG sz, char *mem)
{
   HQUEUE    hq;
   PID       pid;
   APIRET    rc;
   char      wrk[0x0100];
   int       f;

   strcpy(wrk,"\\QUEUES\\");
   strcat(wrk,uin);
   strcat(wrk,".ICQ");

   *( (USHORT *) mem) = 640;

   rc = DosOpenQueue(&pid, &hq, wrk);

   if(!rc)
   {
      rc = DosWriteQueue(hq,ICQCMD_BLOCK,sz,(PVOID) mem,0);
      DosCloseQueue(hq);

      rc = *( (USHORT *) mem );

      for(f=0;f<200 && rc == 640;f++)
      {
         DosSleep(10);
         rc = *( (USHORT *) mem );
      }
   }

   return rc;

}

