/*
 * MSGCMD.C - Envia uma estrutura de comando ao pwICQ, opcionalmente
 * 	      espera resposta
 */


#define INCL_DOSQUEUES
#define INCL_DOSPROCESS
#define INCL_DOSERRORS
#include <stdlib.h>
#include <string.h>

#include <pwicqapi.h>

#include "icqqueue.h"

/*---[ Implementacao ]--------------------------------------------------------*/

APIRET icqSendMsgCmd(ULONG uin, MSGCMD *data, int wait)
{
   HQUEUE    hq;
   PID       pid;
   APIRET    rc;
   int	     f;
   char	     wrk[0x0100];

   strcpy(wrk,"\\QUEUES\\");
   ltoa(uin,wrk+strlen(wrk),10);
   strcat(wrk,".ICQ");

   data->cmd = 0x0B;
   data->ret = DosOpenQueue(&pid, &hq, wrk);

   if(data->ret)
      return data->ret;

   data->ret = DosWriteQueue(hq,ICQCMD_BLOCK,sizeof(MSGCMD),(PVOID) data,0);
   DosCloseQueue(hq);

   if(!data->ret && wait)
   {
      /* Nao deu erro, aguarda a resposta */
      data->ret = ERROR_TIMEOUT;
      for(f=0;f<wait && data->ret == ERROR_TIMEOUT; f++)
	 DosSleep(10);

   }

   return 0;
}


